from fastapi import FastAPI, Request
from fastapi.templating import Jinja2Templates
import uvicorn
import pkg_resources
from starlette.staticfiles import StaticFiles
from fastapi.responses import HTMLResponse

app = FastAPI()

static_path = pkg_resources.resource_filename('reportGeneration', 'web/static')
app.mount("/static", StaticFiles(directory=static_path), name="static")

templates_path = pkg_resources.resource_filename('reportGeneration', 'web/templates')
templates = Jinja2Templates(directory=templates_path)

@app.get("/", response_class=HTMLResponse)
async def home(request: Request):
    return templates.TemplateResponse("index.html", {"request": request})

def run_server(host="127.0.0.1", port=8000):
    uvicorn.run(app, host=host, port=port)
